/**
* Nels Oscar
* 2010
* A single instrument midi sequencer built with 
* algomuse, a slightly modified version of jMusic
*/
import jm.midi.event.*;
import jm.music.data.*;
import jm.music.tools.*;
import jm.audio.*;
import jm.audio.synth.*;
import jm.music.net.*;
import jm.audio.math.*;
import jm.util.*;
import jm.midi.*;
import jm.music.tools.fuzzy.*;
import jm.*;
import jm.constants.*;
import jm.audio.io.*;
import jm.music.rt.*;



int blockW, blockH;
int numRows=60;
int timer=0;
PFont font;
Grid grid;

Muse m;

// GUI declarations
Button play;
Button stop;
Button refresh;
Button sav;

void setup(){
  size(600,700,P2D);
  background(10,20,40);
  m=new Muse();
  font = loadFont("BookmanOldStyle-Bold-20.vlw");
  play = new Button("Play", 10, 620, 55, 30, font);
  stop = new Button("Stop", 75, 620, 55, 30, font);
  refresh = new Button("Refresh", 140, 620, 90, 30, font);
  sav = new Button("Save", 240, 620, 55, 30, font);
  grid=new Grid(width,height-100,numRows);
  setupGUI();
}

void draw(){
  checkRollover(mouseX,mouseY);
}

void setupGUI(){
  play.show();
  stop.show();
  refresh.show();
  sav.show();
}

void keyPressed(){
  if(key=='r'){
    rand(.01);
  }
}

void mousePressed(){
  if(mouseY<=600)
    grid.update(mouseX,mouseY);
  else{
    if(play.contains(mouseX,mouseY)&&timer<=0)
      plaY();
    if(stop.contains(mouseX,mouseY))
      stoP();
    if(refresh.contains(mouseX,mouseY))
      refresH();
    if(sav.contains(mouseX, mouseY))
      savE();
  }
  frameRate(12);
}

void checkRollover(int x, int y){
  play.live(play.contains(x,y));
  stop.live(stop.contains(x,y));
  refresh.live(refresh.contains(x,y));
  sav.live(sav.contains(x,y));
}

void plaY(){
  int inst=m.VIOLA;
  Phrase[] phr=grid.parseGrid();
  println("--Retrieved Score Information--");
  for(int i=0; i< phr.length; i++){
    println("--Added Part--");
    Part p=new Part(inst);
    p.addPhrase(phr[i]);
    println("--Added phrase--");
    println(phr[i]);
    m.score.addPart(p);
  }
  inst++;
  println("--Set Score--");
  m.setScore();
  println("PlaY");
  timer=grid.getLongestRow();
  m.play();
}

void stoP(){
  m.stop();
  println("StoP");
  
}

void refresH(){
  grid.clear();
  println("RefReSH");
}

void savE(){
  int inst=m.VIOLA;
  Phrase[] phr=grid.parseGrid();
  println("--Retrieved Score Information--");
  for(int i=0; i< phr.length; i++){
    println("--Added Part--");
    Part p=new Part(inst);
    p.addPhrase(phr[i]);
    println("--Added phrase--");
    println(phr[i]);
    m.score.addPart(p);
  }
  inst++;
  println("--Set Score--");
  m.setScore();
  println("PlaY");
  Write.midi(m.score,sketchPath("test.mid"));
  m.score.empty();
}

// Density must be less than one
void rand(double density){
  for(int i=0; i<grid.grid.length*density; i++){
    grid.grid[(int)random(0,grid.grid.length-1)].live();
  }
  grid.showBlocks();
}
